<script setup>
import {onMounted, ref} from 'vue';
import {initFlowbite} from 'flowbite';
import {genericError, getCandidates, getChoices, getRCCourse, setChoices} from "@/common/ServerAPI.js";
import CandidateRow from "@/components/CandidateRow.vue";

const WRITER = "WRITER";
const SPEAKER = "SPEAKER";
const ASSISTANT = "ASSISTANT";

function loadCandidates() {
  getCandidates(candidates => {
    JSON.parse(candidates).forEach(item => {
      item.selection = [];
      users.value.push(item);
    });
    loadChoices();
    setTimeout(() => initFlowbite(), 0);
  }, err => {
    if (err !== 403) {
      genericError();
    } else {
      window.location = "/";
    }
  });
}

function loadRCCourse() {
  getRCCourse(course => {
    courseName.value = course;
    loadCandidates();
  }, err => {
    if (err !== 403) {
      genericError();
    } else {
      window.location = "/";
    }
  });
}

function loadChoices() {
  getChoices(course => {
    let parse = JSON.parse(course);
    parse.selections.forEach(selection => {
      users.value.forEach(user => {
        if (user.id === selection.id) {
          if (selection.writer) {
            user.selection.push(WRITER);
          }
          if (selection.speaker) {
            user.selection.push(SPEAKER);
          }
          if (selection.assistant) {
            user.selection.push(ASSISTANT);
          }
          user.confirmed = selection.confirmed;
          user.notes = selection.notes;
        }
      });
    });
  })
}

function saveChoices() {
  let selections = [];
  users.value.forEach(user => {
    selections.push({
      id: user.id,
      writer: user.selection.includes(WRITER),
      speaker: user.selection.includes(SPEAKER),
      assistant: user.selection.includes(ASSISTANT),
      confirmed: user.confirmed,
      notes: user.notes
    });
  });
  setChoices(() => {
  }, genericError, JSON.stringify({id: "", rc: "", selections: selections}));
}

function customLabel(option) {
  switch (option) {
    case WRITER:
      return "Concepteur";
    case SPEAKER:
      return "Speaker";
    case ASSISTANT:
      return "Assistant";
  }
}

function tinyLabel(option) {
  switch (option) {
    case WRITER:
      return "✍️";
    case SPEAKER:
      return "🗣";
    case ASSISTANT:
      return "🤝";
  }
}

onMounted(() => {
  loadRCCourse();
});

const courseName = ref(null);
const users = ref([]);

</script>
<template>
  <!--  Le titre-->
  <div>
    <ul class="flex flex-col text-center space-y space-y-4 text-sm font-medium text-white mb-4 md:mt-20">
      <h2
          class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-6">
        Recrutement du staff (RC {{ courseName }})</h2>
    </ul>
  </div>
  <!--  Pour afficher des infos-->

  <div class="flex justify-center mb-6">
    <div class="flex items-center justify-center w-1/2 p-4 mb-4 text-sm text-blue-800 rounded-lg bg-s4s-redwood-400"
         role="alert">
      <svg class="flex-shrink-0 inline w-4 h-4 me-3" aria-hidden="true" xmlns="http://www.w3.org/2000/svg"
           fill="currentColor" viewBox="0 0 20 20">
        <path
            d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"/>
      </svg>
      <span class="sr-only">Info</span>
      <div>
        <span class="font-medium">Ça serait cool si tous les conflitcs et tous les staff sont enregistrés d'ici la fin de la semaine (Si c'est trop short niveau temps, on peut rajouter une semaine mais dites-le nous)</span>
      </div>
    </div>
  </div>
  <div>
    <!-- todo fix overflow-x-auto -->
    <div class="relative flex md:justify-center overflow-x-auto sm:overflow-x-visible">
      <table class="w-2/3 text-sm text-left rtl:text-right text-gray-500  rounded-md">
        <thead class="text-xs text-gray-700 uppercase bg-s4s-purple-900 text-white  ">
        <tr>
          <th scope="col" class="px-6 py-3">
            Nom
          </th>
          <th scope="col" class="px-6 py-3">
            Telegram | Discord
          </th>
          <th scope="col" class="px-6 py-3">
            Candidature
          </th>
          <th scope="col" class="px-6 py-3">
            Rôles voulus
          </th>
          <th scope="col" class="px-6 py-3">
            Rôles selectionés
          </th>
          <th scope="col" class="px-6 py-3">
            Notes personnelles
          </th>
          <th scope="col" class="px-6 py-3">
            Rôles finaux
          </th>
          <th scope="col" class="px-6 py-3">
            Rôles actuels
          </th>
        </tr>
        </thead>
        <tbody>
        <CandidateRow v-for="user in users" :key="user.id" :user="user"></CandidateRow>
        </tbody>
      </table>
    </div>
  </div>
</template>
